setwd("/home/sesa/Scrivania/")

#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

# File Bug, Entropy File Bug, File Non Bug, Entropy File Non Bug
#id : commit ID
#bug : true if commit is fix inducing changes

#Well known quality metrics
#LOC
#CBO
#LCOM
#NOM
#RFC
#WMC
#MPC

#Subsets
data2 <- data[which(data["LOC"] != "NaN"),]
data3 <- data2[which(data2["CBO"] != "NaN"),] 
data4 <- data3[which(data3["LCOM"] != "NaN"),] 
data5 <- data4[which(data4["NOM"] != "NaN"),] 
data6 <- data5[which(data5["RFC"] != "NaN"),] 
data7 <- data6[which(data6["WMC"] != "NaN"),] 
data8 <- data7[which(data7["MPC"] != "NaN"),] 

bug <- data8[which(data8["bug"] == "true"),]
no_bug <- data8[which(data8["bug"] == "false"),]

#Boxplots
png(file="boxplot_LOC.png")
boxplot(no_bug$LOC, bug$LOC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="LOC", main="LOC", ylim=c(0,150))
dev.off()

png(file="boxplot_CBO.png")
boxplot(no_bug$CBO, bug$CBO, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="CBO", main="CBO", ylim=c(0,100))
dev.off()

png(file="boxplot_LCOM.png")
boxplot(no_bug$LCOM, bug$LCOM, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="LCOM", main="LCOM", ylim=c(0,20))
dev.off()

png(file="boxplot_NOM.png")
boxplot(no_bug$NOM, bug$NOM, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="NOM", main="NOM",ylim=c(0,15))
dev.off()

png(file="boxplot_RFC.png")
boxplot(no_bug$RFC, bug$RFC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="RFC", main="RFC",ylim=c(0,20))
dev.off()

png(file="boxplot_WMC.png")
boxplot(no_bug$WMC, bug$WMC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="WMC", main="WMC", ylim=c(0,30))
dev.off()

png(file="boxplot_MPC.png")
boxplot(no_bug$MPC, bug$MPC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="MPC", main="MPC",ylim=c(0,2))
dev.off()
