setwd("/home/sesa/Scrivania/")
library(xtable)

#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

# File Bug, Entropy File Bug, File Non Bug, Entropy File Non Bug
#id : commit ID
#bug : true if commit is fix inducing changes

#Well known quality metrics
#LOC
#CBO
#LCOM
#NOM
#RFC
#WMC
#MPC

#Subsets
data2 <- data[which(data["LOC"] != "NaN"),]
data3 <- data2[which(data2["CBO"] != "NaN"),] 
data4 <- data3[which(data3["LCOM"] != "NaN"),] 
data5 <- data4[which(data4["NOM"] != "NaN"),] 
data6 <- data5[which(data5["RFC"] != "NaN"),] 
data7 <- data6[which(data6["WMC"] != "NaN"),] 
data8 <- data7[which(data7["MPC"] != "NaN"),] 

bug <- data8[which(data8["bug"] == "true"),]
no_bug <- data8[which(data8["bug"] == "false"),]

print("Summary Xtable")

print("Summary LOC")
m <- matrix(c(as.table(summary(bug$LOC)[1:6])[1:6], as.table(summary(no_bug$LOC)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)
print("Summary CBO")
m <- matrix(c(as.table(summary(bug$CBO)[1:6])[1:6], as.table(summary(no_bug$CBO)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)
print("Summary LCOM")
m <- matrix(c(as.table(summary(bug$LCOM)[1:6])[1:6], as.table(summary(no_bug$LCOM)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)
print("Summary NOM")
m <- matrix(c(as.table(summary(bug$NOM)[1:6])[1:6], as.table(summary(no_bug$NOM)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)
print("Summary RFC")
m <- matrix(c(as.table(summary(bug$RFC)[1:6])[1:6], as.table(summary(no_bug$RFC)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)
print("Summary WMC")
m <- matrix(c(as.table(summary(bug$WMC)[1:6])[1:6], as.table(summary(no_bug$WMC)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)
print("Summary MPC")
m <- matrix(c(as.table(summary(bug$MPC)[1:6])[1:6], as.table(summary(no_bug$MPC)[1:6])[1:6]), nrow=2, ncol=6, byrow=TRUE)
rownames(m)=c("BUG", "NO BUG")
colnames(m)=c("Min.","1st Qu.","Median","Mean", "3rd Qu.","Max.")
xtable(m)


