setwd("/home/sesa/Scrivania/")
pdf("/home/sesa/Scrivania/boxplots.pdf")
#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

# File Bug, Entropy File Bug, File Non Bug, Entropy File Non Bug
#id : commit ID
#bug : true if commit is fix inducing changes

#Well known quality metrics
#LOC
#CBO
#LCOM
#NOM
#RFC
#WMC
#MPC

#Subsets
data2 <- data[which(data["LOC"] != "NaN"),]
data3 <- data2[which(data2["CBO"] != "NaN"),] 
data4 <- data3[which(data3["LCOM"] != "NaN"),] 
data5 <- data4[which(data4["NOM"] != "NaN"),] 
data6 <- data5[which(data5["RFC"] != "NaN"),] 
data7 <- data6[which(data6["WMC"] != "NaN"),] 
data8 <- data7[which(data7["MPC"] != "NaN"),] 

bug <- data8[which(data8["bug"] == "true"),]
no_bug <- data8[which(data8["bug"] == "false"),]

#Summary info
print("----------- Summary Info -----------")
print("Summary LOC (BUG)")
summary(bug$LOC)
print("Summary LOC (NO_BUG)")
summary(no_bug$LOC)
print("Summary CBO (BUG)")
summary(bug$CBO)
print("Summary CBO (NO_BUG)")
summary(no_bug$CBO)
print("Summary LCOM (BUG)")
summary(bug$LCOM)
print("Summary LCOM (NO_BUG)")
summary(no_bug$LCOM)
print("Summary NOM (BUG)")
summary(bug$NOM)
print("Summary NOM (NO_BUG)")
summary(no_bug$NOM)
print("Summary RFC (BUG)")
summary(bug$RFC)
print("Summary RFC (NO_BUG)")
summary(no_bug$RFC)
print("Summary WMC (BUG)")
summary(bug$WMC)
print("Summary WMC (NO_BUG)")
summary(no_bug$WMC)
print("Summary MPC (BUG)")
summary(bug$MPC)
print("Summary MPC (NO_BUG)")
summary(no_bug$MPC)


#Boxplots
#Similarity
boxplot(no_bug$LOC, bug$LOC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="LOC", main="LOC")
boxplot(no_bug$CBO, bug$CBO, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="CBO", main="CBO")
boxplot(no_bug$LCOM, bug$LCOM, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="LCOM", main="LCOM")
boxplot(no_bug$NOM, bug$NOM, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="NOM", main="NOM")
boxplot(no_bug$RFC, bug$RFC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="RFC", main="RFC")
boxplot(no_bug$WMC, bug$WMC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="WMC", main="WMC")
boxplot(no_bug$MPC, bug$MPC, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="MPC", main="MPC")

#Statistical test
print("----------- Statistical Test - WilcoxTest -----------")
wilcox.test(no_bug$LOC, bug$LOC,alternative="less",paired=FALSE)
wilcox.test(no_bug$CBO, bug$CBO,alternative="less",paired=FALSE)
wilcox.test(no_bug$LCOM, bug$LCOM,alternative="less",paired=FALSE)
wilcox.test(no_bug$NOM, bug$NOM,alternative="less",paired=FALSE)
wilcox.test(no_bug$RFC, bug$RFC,alternative="less",paired=FALSE)
wilcox.test(no_bug$WMC, bug$WMC,alternative="less",paired=FALSE)
wilcox.test(bug$MPC, no_bug$MPC,alternative="less",paired=FALSE)

library(orddom)

#small for d < 0.33 (positive as well as negative values), 
#medium for 0.33 ≤ d < 0.474 and large for d ≥ 0.474.
#Summary info
print("----------- Cliff's Delta -----------")
#print("LOC")
#t1=as.matrix(no_bug$LOC)
#colnames(t1)<-c("t1")
#t2=as.matrix(bug$LOC)
#colnames(t2)<-c("t2")
#o<-orddom(t1,t2)
#cliffdelta<-o[13,1]
#cliffdelta
print("CBO")
t1=as.matrix(no_bug$CBO)
colnames(t1)<-c("t1")
t2=as.matrix(bug$CBO)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta
print("LCOM")
t1=as.matrix(no_bug$LCOM)
colnames(t1)<-c("t1")
t2=as.matrix(bug$LCOM)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta
print("NOM")
t1=as.matrix(no_bug$NOM)
colnames(t1)<-c("t1")
t2=as.matrix(bug$NOM)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta
print("RFC")
t1=as.matrix(no_bug$RFC)
colnames(t1)<-c("t1")
t2=as.matrix(bug$RFC)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta
print("WMC")
t1=as.matrix(no_bug$WMC)
colnames(t1)<-c("t1")
t2=as.matrix(bug$WMC)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta
print("MPC")
t1=as.matrix(no_bug$MPC)
colnames(t1)<-c("t1")
t2=as.matrix(bug$MPC)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta



dev.off()
