setwd("/home/sesa/Scrivania/")
pdf("boxplots")
#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

#id,bug,lines,hunks

#Subsets
bug <- data[which(data["bug"] == "true"),]
no_bug <- data[which(data["bug"] == "false"),]

#Summary info
print("----------- Summary Info -----------")
print("Summary Lines (BUG)")
summary(bug$lines)
print("Summary Lines (NO_BUG)")
summary(no_bug$lines)
print("Summary Hunks (BUG)")
summary(bug$hunks)
print("Summary Hunks (NO_BUG)")
summary(no_bug$hunks)

#Boxplots
boxplot(no_bug$lines, bug$lines, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Num of Lines", main="Lines", ylim=c(0,100))
boxplot(no_bug$hunks, bug$hunks, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Num of Hunks", main="Hunks", ylim=c(0,100))

dev.off()

#Statistical test
print("----------- Statistical Test - WilcoxTest -----------")
print("Lines")
wilcox.test(no_bug$lines, bug$lines,alternative="less",paired=FALSE)
print("Hunks")
wilcox.test(no_bug$hunks, bug$hunks,alternative="less",paired=FALSE)

library(orddom)

#small for d < 0.33 (positive as well as negative values), 
#medium for 0.33 ≤ d < 0.474 and large for d ≥ 0.474.
#Summary info
print("----------- Cliff's Delta -----------")
print("Lines")
t1=as.matrix(no_bug$lines)
colnames(t1)<-c("t1")
t2=as.matrix(bug$lines)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta

print("Hunks")
t1=as.matrix(no_bug$hunks)
colnames(t1)<-c("t1")
t2=as.matrix(bug$hunks)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta


