setwd("/home/sesa/Scrivania/")
pdf("/home/sesa/Scrivania/boxplots.pdf")
#Load Data
data<-read.table("stats.csv",sep=",",header=TRUE)

#id,bug,structuralFocus

#Subsets
bug <- data[which(data["bug"] == "true"),]
no_bug <- data[which(data["bug"] == "false"),]

#Summary info
print("----------- Summary Info -----------")
print("Summary Structural Focus (BUG)")
summary(bug$structuralFocus)
print("Summary Structural Focus (NO_BUG)")
summary(no_bug$structuralFocus)

#Boxplots
boxplot(no_bug$structuralFocus, bug$structuralFocus, col="gray", boxwex = 0.25, at = 1:2 - 0.0, names = c("NO","YES"), xlab="Fix Inducing Changes", ylab="Structural Focus", main="Structural Focus")

#Statistical test
print("----------- Statistical Test - WilcoxTest -----------")
wilcox.test(no_bug$structuralFocus, bug$structuralFocus,alternative="less",paired=FALSE)

library(orddom)

#small for d < 0.33 (positive as well as negative values), 
#medium for 0.33 ≤ d < 0.474 and large for d ≥ 0.474.
#Summary info
print("----------- Cliff's Delta -----------")
print("Structural Focus")
t1=as.matrix(no_bug$structuralFocus)
colnames(t1)<-c("t1")
t2=as.matrix(bug$structuralFocus)
colnames(t2)<-c("t2")
o<-orddom(t1,t2)
cliffdelta<-o[13,1]
cliffdelta

dev.off()
